import type { APIApplicationCommand, PermissionFlagsBits, RESTPostAPIContextMenuApplicationCommandsJSONBody } from "discord-api-types/v10";
import type ContextMenuInteraction from "../interactions/application-commands/context-menu-interaction.js";
import type { ContextMenuApplicationCommandType } from "../interactions/application-commands/context-menu-interaction.js";
import type { InteractionKitCommand, ValueOf } from "../interfaces.js";
declare type ContextMenuArgs<T extends ContextMenuApplicationCommandType> = {
    name: string;
    type: T;
    defaultPermissions?: Array<ValueOf<typeof PermissionFlagsBits>>;
    handler: InteractionKitCommand<ContextMenuInteraction<T>>["handler"];
};
export default class ContextMenu<T extends ContextMenuApplicationCommandType> implements InteractionKitCommand<ContextMenuInteraction<T>> {
    name: string;
    type: T;
    defaultPermissions: null | bigint;
    handler: InteractionKitCommand<ContextMenuInteraction<T>>["handler"];
    constructor({ name, type, defaultPermissions, handler }: ContextMenuArgs<T>);
    equals(schema: APIApplicationCommand): boolean;
    serialize(): RESTPostAPIContextMenuApplicationCommandsJSONBody;
}
export {};
