export default class ContextMenu {
    constructor({ name, type, defaultPermissions, handler }) {
        // TODO: Validate: 1-32 lowercase character name matching ^[\w-]{1,32}$
        this.name = name;
        this.type = type;
        this.handler = handler;
        this.defaultPermissions =
            defaultPermissions?.reduce((value, permission) => value | permission, 0n) ?? null;
    }
    equals(schema) {
        if (this.name !== schema.name || this.type !== schema.type) {
            return false;
        }
        if (this.defaultPermissions !== schema.default_member_permissions) {
            return false;
        }
        return true;
    }
    serialize() {
        const payload = {
            name: this.name,
            type: this.type,
        };
        if (this.defaultPermissions != null) {
            payload.default_member_permissions = this.defaultPermissions.toString();
        }
        return payload;
    }
}
//# sourceMappingURL=context-menu.js.map