import type { APIApplicationCommandChannelOption } from "discord-api-types/v10";
import type { Optional } from "../../interfaces.js";
import type { BaseBasicOptionArgs } from "./option.js";
import { BasicOption } from "./option.js";
declare type ChannelOptionArgs = {
    channelTypes?: APIApplicationCommandChannelOption["channel_types"] | undefined;
} & Optional<BaseBasicOptionArgs, "required">;
export default class ChannelOption extends BasicOption<APIApplicationCommandChannelOption> {
    readonly channelTypes: APIApplicationCommandChannelOption["channel_types"] | undefined;
    constructor({ name, description, required, channelTypes, }: ChannelOptionArgs);
    serialize(): APIApplicationCommandChannelOption;
    equals(schema: APIApplicationCommandChannelOption): boolean;
}
export {};
