import { ApplicationCommandOptionType } from "discord-api-types/v10";
import { isEqual } from "../../helpers/arrays.js";
import { BasicOption } from "./option.js";
export default class ChannelOption extends BasicOption {
    constructor({ name, description, required, channelTypes, }) {
        super({
            type: ApplicationCommandOptionType.Channel,
            name,
            description,
            required,
        });
        this.channelTypes = channelTypes;
    }
    serialize() {
        const payload = super.serialize();
        if (this.channelTypes != null) {
            payload.channel_types = this.channelTypes;
        }
        return payload;
    }
    equals(schema) {
        return (super.equals(schema) && isEqual(this.channelTypes, schema.channel_types));
    }
}
//# sourceMappingURL=channel.js.map