import type { APIApplicationCommandOptionChoice, APISelectMenuOption } from "discord-api-types/v10";
import type { Serializable } from "../../interfaces.js";
export declare type ChoiceType = APIApplicationCommandOptionChoice | APISelectMenuOption;
export declare class Choices<T extends ChoiceType> implements Serializable {
    _choices: Map<string, T>;
    constructor(choices: Record<string, T>);
    static create<T extends ChoiceType, U extends Record<string, T>>(this: typeof Choices, choices: U): Choices<T> & U;
    serialize(): T[];
}
export declare class SelectOptionList extends Choices<APISelectMenuOption> {
    constructor(choices: Record<string, APISelectMenuOption["value"] | APISelectMenuOption>);
}
export declare class SlashChoiceList<T extends APIApplicationCommandOptionChoice["value"]> extends Choices<APIApplicationCommandOptionChoice<T>> {
    constructor(choices: Record<string, T | APIApplicationCommandOptionChoice<T>>);
}
