import type { APIApplicationCommandIntegerOption } from "discord-api-types/v10";
import { ApplicationCommandOptionType } from "discord-api-types/v10";
import type SlashCommandAutocompleteInteraction from "../../interactions/autocomplete/application-command-autocomplete.js";
import type { Autocomplete } from "../../interactions/autocomplete/types.js";
import type { Optional } from "../../interfaces.js";
import type { SlashChoiceList } from "./choices.js";
import type { AutocompleteCommandOptionType, BaseBasicOptionArgs } from "./option.js";
import { BasicOption } from "./option.js";
interface IntegerOptionChoiceArgs extends Optional<BaseBasicOptionArgs, "required"> {
    choices?: SlashChoiceList<number>;
    autocomplete: never;
}
interface IntegerAutocompleteArgs extends Optional<BaseBasicOptionArgs, "required"> {
    choices: never;
    autocomplete: Autocomplete<SlashCommandAutocompleteInteraction>["autocomplete"];
}
export default class IntegerOption extends BasicOption<APIApplicationCommandIntegerOption> implements Autocomplete<SlashCommandAutocompleteInteraction> {
    readonly choices: SlashChoiceList<number> | undefined;
    autocomplete?: Autocomplete<SlashCommandAutocompleteInteraction>["autocomplete"];
    constructor({ choices, autocomplete, name, description, required, }: IntegerOptionChoiceArgs | IntegerAutocompleteArgs);
    isAutocomplete(_payload: APIApplicationCommandIntegerOption): _payload is AutocompleteCommandOptionType<ApplicationCommandOptionType.Integer>;
    equals(schema: APIApplicationCommandIntegerOption): boolean;
    serialize(): APIApplicationCommandIntegerOption;
}
export {};
