import type { APIApplicationCommandNumberOption } from "discord-api-types/v10";
import { ApplicationCommandOptionType } from "discord-api-types/v10";
import type SlashCommandAutocompleteInteraction from "../../interactions/autocomplete/application-command-autocomplete.js";
import type { Autocomplete } from "../../interactions/autocomplete/types.js";
import type { Optional } from "../../interfaces.js";
import type { SlashChoiceList } from "./choices.js";
import type { AutocompleteCommandOptionType, BaseBasicOptionArgs } from "./option.js";
import { BasicOption } from "./option.js";
interface NumberOptionChoiceArgs extends Optional<BaseBasicOptionArgs, "required"> {
    choices?: SlashChoiceList<number>;
    autocomplete: never;
}
interface NumberAutocompleteArgs extends Optional<BaseBasicOptionArgs, "required"> {
    choices: never;
    autocomplete: Autocomplete<SlashCommandAutocompleteInteraction>["autocomplete"];
}
export default class NumberOption extends BasicOption<APIApplicationCommandNumberOption> implements Autocomplete<SlashCommandAutocompleteInteraction> {
    readonly choices: SlashChoiceList<number> | undefined;
    autocomplete?: Autocomplete<SlashCommandAutocompleteInteraction>["autocomplete"];
    constructor({ choices, autocomplete, name, description, required, }: NumberOptionChoiceArgs | NumberAutocompleteArgs);
    isAutocomplete(_payload: APIApplicationCommandNumberOption): _payload is AutocompleteCommandOptionType<ApplicationCommandOptionType.Number>;
    equals(schema: APIApplicationCommandNumberOption): boolean;
    serialize(): APIApplicationCommandNumberOption;
}
export {};
