import type { APIApplicationCommandBasicOption, APIApplicationCommandInteractionDataBasicOption, APIApplicationCommandInteractionDataIntegerOption, APIApplicationCommandInteractionDataNumberOption, APIApplicationCommandInteractionDataOption, APIApplicationCommandInteractionDataStringOption, APIApplicationCommandOption, APIApplicationCommandOptionBase } from "discord-api-types/v10";
import { ApplicationCommandOptionType } from "discord-api-types/v10";
import type { Comparable, Serializable } from "../../interfaces.js";
declare type OptionArgs = {
    type: ApplicationCommandOptionType;
    name: string;
    description: string;
};
export declare type BaseOptionArgs = Omit<OptionArgs, "type">;
export declare type APIApplicationCommandInteractionDataAutocompleteOption = APIApplicationCommandInteractionDataStringOption | APIApplicationCommandInteractionDataIntegerOption | APIApplicationCommandInteractionDataNumberOption;
export declare type AutocompleteOptionTypes = AutocompleteCommandOptionType<ApplicationCommandOptionType.String> | AutocompleteCommandOptionType<ApplicationCommandOptionType.Number> | AutocompleteCommandOptionType<ApplicationCommandOptionType.Integer>;
export declare function isBasicOption(option: APIApplicationCommandInteractionDataOption): option is APIApplicationCommandInteractionDataBasicOption;
export declare function isAutocompleteOption(option: APIApplicationCommandInteractionDataOption): option is APIApplicationCommandInteractionDataAutocompleteOption;
export declare type AutocompleteCommandOptionType<T extends ApplicationCommandOptionType> = APIApplicationCommandOptionBase<T> & {
    autocomplete: true;
};
export declare class Option implements Serializable<APIApplicationCommandOption>, Comparable<APIApplicationCommandOption> {
    readonly type: ApplicationCommandOptionType;
    readonly name: string;
    readonly description: string;
    constructor({ type, name, description }: OptionArgs);
    isAutocomplete(_payload?: APIApplicationCommandOption): _payload is AutocompleteOptionTypes;
    serialize(): APIApplicationCommandOption;
    equals(schema: APIApplicationCommandOption): boolean;
}
interface BasicOptionArgs extends OptionArgs {
    required: boolean | undefined;
}
export declare type BaseBasicOptionArgs = Omit<BasicOptionArgs, "type">;
export declare class BasicOption<T extends APIApplicationCommandBasicOption = APIApplicationCommandBasicOption> extends Option {
    readonly required: boolean | undefined;
    constructor({ name, description, type, required }: BasicOptionArgs);
    serialize(): T;
    equals(schema: APIApplicationCommandBasicOption): boolean;
}
export {};
