import { ApplicationCommandOptionType } from "discord-api-types/v10";
// TODO: Upstream?
export function isBasicOption(option) {
    return (option.type !== ApplicationCommandOptionType.Subcommand &&
        option.type !== ApplicationCommandOptionType.SubcommandGroup);
}
// TODO: Upstream?
export function isAutocompleteOption(option) {
    return (option.type === ApplicationCommandOptionType.String ||
        option.type === ApplicationCommandOptionType.Integer ||
        option.type === ApplicationCommandOptionType.Number);
}
export class Option {
    constructor({ type, name, description }) {
        this.type = type;
        this.name = name;
        this.description = description;
    }
    isAutocomplete(_payload) {
        return false;
    }
    serialize() {
        // eslint-disable-next-line @typescript-eslint/consistent-type-assertions
        return {
            type: this.type,
            name: this.name,
            description: this.description,
        };
    }
    equals(schema) {
        if (this.type !== schema.type ||
            this.name !== schema.name ||
            this.description !== schema.description) {
            return false;
        }
        return true;
    }
}
export class BasicOption extends Option {
    constructor({ name, description, type, required }) {
        super({
            type,
            name,
            description,
        });
        this.required = required;
    }
    serialize() {
        if (this.required === undefined) {
            return super.serialize();
        }
        // eslint-disable-next-line @typescript-eslint/consistent-type-assertions
        return {
            ...super.serialize(),
            required: this.required,
        };
    }
    equals(schema) {
        return super.equals(schema) && this.required === schema.required;
    }
}
//# sourceMappingURL=option.js.map