import type { APIApplicationCommandStringOption } from "discord-api-types/v10";
import { ApplicationCommandOptionType } from "discord-api-types/v10";
import type SlashCommandAutocompleteInteraction from "../../interactions/autocomplete/application-command-autocomplete.js";
import type { Autocomplete } from "../../interactions/autocomplete/types.js";
import type { Optional } from "../../interfaces.js";
import type { SlashChoiceList } from "./choices.js";
import type { AutocompleteCommandOptionType, BaseBasicOptionArgs } from "./option.js";
import { BasicOption } from "./option.js";
interface StringOptionChoiceArgs extends Optional<BaseBasicOptionArgs, "required"> {
    choices?: SlashChoiceList<string>;
    autocomplete: never;
}
interface StringAutocompleteArgs extends Optional<BaseBasicOptionArgs, "required"> {
    choices: never;
    autocomplete: Autocomplete<SlashCommandAutocompleteInteraction>["autocomplete"];
}
export default class StringOption extends BasicOption<APIApplicationCommandStringOption> implements Autocomplete<SlashCommandAutocompleteInteraction> {
    readonly choices: SlashChoiceList<string> | undefined;
    autocomplete?: Autocomplete<SlashCommandAutocompleteInteraction>["autocomplete"];
    constructor({ choices, autocomplete, name, description, required, }: StringOptionChoiceArgs | StringAutocompleteArgs);
    isAutocomplete(_payload: APIApplicationCommandStringOption): _payload is AutocompleteCommandOptionType<ApplicationCommandOptionType.String>;
    equals(schema: APIApplicationCommandStringOption): boolean;
    serialize(): APIApplicationCommandStringOption;
}
export {};
