import type { APIApplicationCommandSubcommandGroupOption } from "discord-api-types/v10";
import { ApplicationCommandOptionType } from "discord-api-types/v10";
import type { BaseOptionArgs } from "./option.js";
import { Option } from "./option.js";
import type Subcommand from "./subcommand.js";
declare type SubcommandGroupArgs = {
    subcommands: Subcommand[];
} & BaseOptionArgs;
export default class SubcommandGroup extends Option {
    readonly type = ApplicationCommandOptionType.SubcommandGroup;
    readonly subcommands: Map<string, Subcommand>;
    constructor({ name, description, subcommands }: SubcommandGroupArgs);
    serialize(): APIApplicationCommandSubcommandGroupOption;
    equals(schema: APIApplicationCommandSubcommandGroupOption): boolean;
}
export {};
