import type { APIApplicationCommandSubcommandOption } from "discord-api-types/v10";
import { ApplicationCommandOptionType } from "discord-api-types/v10";
import type SlashCommandInteraction from "../../interactions/application-commands/slash-command-interaction.js";
import type SlashCommandAutocompleteInteraction from "../../interactions/autocomplete/application-command-autocomplete.js";
import type { Autocomplete } from "../../interactions/autocomplete/types.js";
import type { InteractionKitCommand } from "../../interfaces.js";
import type { AutocompleteCommandArgs, CommandArgs } from "../slash-command.js";
import type { BasicOption } from "./option.js";
import { Option } from "./option.js";
export default class Subcommand extends Option implements Omit<InteractionKitCommand<SlashCommandInteraction>, "type" | "serialize" | "equals">, Autocomplete<SlashCommandAutocompleteInteraction> {
    readonly type = ApplicationCommandOptionType.Subcommand;
    options: Map<string, BasicOption>;
    handler: InteractionKitCommand<SlashCommandInteraction>["handler"];
    autocomplete?: Autocomplete<SlashCommandAutocompleteInteraction>["autocomplete"];
    constructor({ name, description, options, handler, autocomplete, }: CommandArgs | AutocompleteCommandArgs);
    equals(schema: APIApplicationCommandSubcommandOption): boolean;
    serialize(): APIApplicationCommandSubcommandOption;
}
