import type { APIActionRowComponent, APIMessageActionRowComponent } from "discord-api-types/v10";
import { ComponentType } from "discord-api-types/v10";
import type { SerializableComponent } from "../interfaces.js";
import type { Button } from "./button.js";
import type Select from "./select.js";
export declare function isActionRow(component: SerializableComponent): component is ActionRow;
export declare type ActionRowChildren = Button | Select;
export default class ActionRow implements SerializableComponent {
    components: ActionRowChildren[];
    constructor(...components: ActionRowChildren[]);
    get id(): undefined;
    get type(): ComponentType;
    get isFull(): boolean;
    setComponents(...components: ActionRowChildren[]): void;
    addComponent(component: ActionRowChildren): void;
    serialize(): APIActionRowComponent<APIMessageActionRowComponent>;
}
