var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _ButtonBase_style, _ButtonBase_label, _ButtonBase_emoji, _ButtonBase_disabled, _ButtonLink_url, _Button_customId;
import { ButtonStyle, ComponentType } from "discord-api-types/v10";
class ButtonBase {
    constructor({ label, emoji, disabled, style }) {
        _ButtonBase_style.set(this, void 0);
        _ButtonBase_label.set(this, void 0);
        _ButtonBase_emoji.set(this, void 0);
        _ButtonBase_disabled.set(this, void 0);
        __classPrivateFieldSet(this, _ButtonBase_label, label, "f");
        __classPrivateFieldSet(this, _ButtonBase_emoji, emoji, "f");
        __classPrivateFieldSet(this, _ButtonBase_disabled, disabled, "f");
        __classPrivateFieldSet(this, _ButtonBase_style, style, "f");
    }
    get id() {
        return undefined;
    }
    get type() {
        return ComponentType.Button;
    }
    setLabel(label) {
        __classPrivateFieldSet(this, _ButtonBase_label, label, "f");
        return this;
    }
    setEmoji(emoji) {
        __classPrivateFieldSet(this, _ButtonBase_emoji, emoji, "f");
        return this;
    }
    setDisabled(disabled) {
        __classPrivateFieldSet(this, _ButtonBase_disabled, disabled, "f");
        return this;
    }
    serialize() {
        const payload = {
            type: ComponentType.Button,
            style: __classPrivateFieldGet(this, _ButtonBase_style, "f"),
        };
        if (__classPrivateFieldGet(this, _ButtonBase_label, "f") != null) {
            payload.label = __classPrivateFieldGet(this, _ButtonBase_label, "f");
        }
        if (__classPrivateFieldGet(this, _ButtonBase_emoji, "f") != null) {
            payload.emoji = __classPrivateFieldGet(this, _ButtonBase_emoji, "f");
        }
        if (__classPrivateFieldGet(this, _ButtonBase_disabled, "f") != null) {
            payload.disabled = __classPrivateFieldGet(this, _ButtonBase_disabled, "f");
        }
        return payload;
    }
    setStyle(style) {
        __classPrivateFieldSet(this, _ButtonBase_style, style, "f");
        return this;
    }
}
_ButtonBase_style = new WeakMap(), _ButtonBase_label = new WeakMap(), _ButtonBase_emoji = new WeakMap(), _ButtonBase_disabled = new WeakMap();
export class ButtonLink extends ButtonBase {
    constructor({ disabled, emoji, label, url }) {
        super({
            disabled,
            emoji,
            label,
            style: ButtonStyle.Link,
        });
        _ButtonLink_url.set(this, void 0);
        __classPrivateFieldSet(this, _ButtonLink_url, url, "f");
    }
    setURL(url) {
        __classPrivateFieldSet(this, _ButtonLink_url, url, "f");
        return this;
    }
    serialize() {
        const base = super.serialize();
        return {
            ...base,
            url: __classPrivateFieldGet(this, _ButtonLink_url, "f"),
        };
    }
}
_ButtonLink_url = new WeakMap();
export class Button extends ButtonBase {
    constructor({ handler, customId, style, matches, disabled, emoji, label, }) {
        super({
            disabled,
            emoji,
            label,
            style: style ?? ButtonStyle.Primary,
        });
        _Button_customId.set(this, void 0);
        __classPrivateFieldSet(this, _Button_customId, customId, "f");
        this.matches = matches;
        this.handler = handler;
        if (__classPrivateFieldGet(this, _Button_customId, "f") == null) {
            throw new Error("Custom ID is required");
        }
    }
    get id() {
        return __classPrivateFieldGet(this, _Button_customId, "f");
    }
    setCustomId(customId) {
        __classPrivateFieldSet(this, _Button_customId, customId, "f");
        return this;
    }
    setStyle(style) {
        super.setStyle(style);
        return this;
    }
    setHandler(fn) {
        this.handler = fn;
        return this;
    }
    setMatches(fn) {
        this.matches = fn;
        return this;
    }
    serialize() {
        const base = super.serialize();
        return {
            ...base,
            custom_id: __classPrivateFieldGet(this, _Button_customId, "f"),
        };
    }
}
_Button_customId = new WeakMap();
//# sourceMappingURL=button.js.map