import type { APISelectMenuComponent } from "discord-api-types/v10";
import { ComponentType } from "discord-api-types/v10";
import type { SelectOptionList } from "../commands/options/index.js";
import type SelectInteraction from "../interactions/message-components/select-interaction.js";
import type { Executable, SerializableComponent } from "../interfaces.js";
declare type SelectArgs = {
    matches?: Executable<SelectInteraction>["matches"];
    customId: APISelectMenuComponent["custom_id"];
    handler: Executable<SelectInteraction>["handler"];
    min: APISelectMenuComponent["min_values"];
    max: APISelectMenuComponent["max_values"];
    options: SelectOptionList;
} & Omit<APISelectMenuComponent, "type" | "url" | "custom_id" | "components" | "min_values" | "max_values" | "options">;
export default class Select implements SerializableComponent, Executable<SelectInteraction> {
    #private;
    options: SelectArgs["options"];
    matches: SelectArgs["matches"];
    handler: SelectArgs["handler"];
    constructor({ customId, options, placeholder, min, max, disabled, matches, handler, }: SelectArgs);
    get id(): string;
    get type(): ComponentType;
    setCustomId(customId: SelectArgs["customId"]): this;
    setPlaceholder(placeholder: SelectArgs["placeholder"]): this;
    setMin(min: SelectArgs["min"]): this;
    setMax(max: SelectArgs["max"]): this;
    setDisabled(disabled: SelectArgs["disabled"]): this;
    setHandler(fn: SelectArgs["handler"]): this;
    setMatches(fn: SelectArgs["matches"]): this;
    serialize(): APISelectMenuComponent;
}
export {};
