import type { APIApplicationCommandInteraction, APIInteractionGuildMember } from "discord-api-types/v10";
import { InteractionType } from "discord-api-types/v10";
import type { Snowflake } from "discord-snowflake";
import type Application from "../../application.js";
import type { Interaction, InteractionMessageModifiers, InteractionReply, RequestBody, ResponseHandler } from "../../interfaces.js";
export default class ApplicationCommandInteraction implements Interaction {
    #private;
    readonly type = InteractionType.ApplicationCommand;
    readonly name: string;
    readonly token: string;
    readonly messages: InteractionMessageModifiers;
    readonly channelId: Snowflake | undefined;
    readonly guildId: Snowflake | undefined;
    readonly member: APIInteractionGuildMember | undefined;
    constructor(application: Application, json: RequestBody<APIApplicationCommandInteraction>, respond: ResponseHandler);
    defer(): Promise<void>;
    reply({ message, embed, components, ephemeral, queue, }: InteractionReply): Promise<string>;
}
