var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _ApplicationCommandInteraction_respond, _ApplicationCommandInteraction_application, _ApplicationCommandInteraction_replied;
import { createInteractionFollowup, deleteInteractionFollowup, editInteractionFollowup, } from "discord-api-methods";
import { InteractionResponseType, InteractionType, MessageFlags, } from "discord-api-types/v10";
import Config from "../../config.js";
import { ResponseStatus } from "../../requests/response.js";
export default class ApplicationCommandInteraction {
    constructor(application, json, respond) {
        this.type = InteractionType.ApplicationCommand;
        _ApplicationCommandInteraction_respond.set(this, void 0);
        _ApplicationCommandInteraction_application.set(this, void 0);
        _ApplicationCommandInteraction_replied.set(this, void 0);
        __classPrivateFieldSet(this, _ApplicationCommandInteraction_application, application, "f");
        __classPrivateFieldSet(this, _ApplicationCommandInteraction_respond, respond, "f");
        this.token = json.token;
        this.name = json.data.name ?? "";
        // TEMPORARY
        this.member = json.member;
        __classPrivateFieldSet(this, _ApplicationCommandInteraction_replied, false, "f");
        this.messages = {
            edit: async (data, id = "@original") => editInteractionFollowup(Config.getApplicationId(), this.token, id, data),
            delete: async (id = "@original") => deleteInteractionFollowup(Config.getApplicationId(), this.token, id),
        };
    }
    async defer() {
        return __classPrivateFieldGet(this, _ApplicationCommandInteraction_respond, "f").call(this, ResponseStatus.OK, {
            type: InteractionResponseType.DeferredChannelMessageWithSource,
        });
    }
    // TODO: This is mostly shared with message-component-interaction
    async reply({ message, embed, components, ephemeral = false, queue = false, }) {
        const payload = {
            type: InteractionResponseType.ChannelMessageWithSource,
            data: {},
        };
        if (message != null) {
            payload.data.content = message;
        }
        if (ephemeral) {
            payload.data.flags = MessageFlags.Ephemeral;
        }
        if (embed != null) {
            payload.data.embeds = []
                .concat(embed)
                .map((item) => item.serialize());
        }
        if (components != null) {
            payload.data.components = components.map((component) => {
                // Register all child components while we're here
                component.components.forEach((child) => {
                    __classPrivateFieldGet(this, _ApplicationCommandInteraction_application, "f").addComponent(child);
                });
                return component.serialize();
            });
        }
        if (!__classPrivateFieldGet(this, _ApplicationCommandInteraction_replied, "f") && !queue) {
            __classPrivateFieldSet(this, _ApplicationCommandInteraction_replied, true, "f");
            await __classPrivateFieldGet(this, _ApplicationCommandInteraction_respond, "f").call(this, ResponseStatus.OK, payload);
            return "@original";
        }
        const responseData = await createInteractionFollowup(Config.getApplicationId(), this.token, payload.data);
        return responseData.id;
    }
}
_ApplicationCommandInteraction_respond = new WeakMap(), _ApplicationCommandInteraction_application = new WeakMap(), _ApplicationCommandInteraction_replied = new WeakMap();
//# sourceMappingURL=application-command-interaction.js.map