import type { APIContextMenuInteraction } from "discord-api-types/v10";
import { ApplicationCommandType } from "discord-api-types/v10";
import type Application from "../../application.js";
import type { InteractionKitCommand, RequestBody, ResponseHandler } from "../../interfaces.js";
import ApplicationCommandInteraction from "./application-command-interaction.js";
export declare type ContextMenuApplicationCommandType = Exclude<ApplicationCommandType, ApplicationCommandType.ChatInput>;
declare type MessageTargetType = {
    pinned: boolean;
};
declare type UserTargetType = {
    bot: boolean;
};
declare type TargetType<T extends ContextMenuApplicationCommandType> = T extends ApplicationCommandType.Message ? MessageTargetType : T extends ApplicationCommandType.User ? UserTargetType : unknown;
export default class ContextMenuInteraction<T extends ContextMenuApplicationCommandType> extends ApplicationCommandInteraction {
    readonly commandType: T;
    readonly target: TargetType<T>;
    constructor(application: Application, command: InteractionKitCommand<ContextMenuInteraction<T>>, json: RequestBody<APIContextMenuInteraction>, respond: ResponseHandler);
}
export {};
