import { ApplicationCommandType } from "discord-api-types/v10";
import ApplicationCommandInteraction from "./application-command-interaction.js";
export default class ContextMenuInteraction extends ApplicationCommandInteraction {
    constructor(application, command, json, respond) {
        super(application, json, respond);
        const id = json.data.target_id;
        // TODO: Clean this up
        switch (json.data?.type) {
            case ApplicationCommandType.Message:
                // @ts-expect-error This is set at runtime but it's guaranteed to be the generic
                this.commandType = ApplicationCommandType.Message;
                // @ts-expect-error Same as above
                this.target = (json.data?.resolved?.messages?.[id] ??
                    {});
                break;
            case ApplicationCommandType.User:
                // @ts-expect-error This is set at runtime but it's guaranteed to be the generic
                this.commandType = ApplicationCommandType.User;
                // @ts-expect-error Same as above
                this.target = {
                    ...(json.data?.resolved?.members?.[id] ?? {}),
                    ...(json.data?.resolved?.users?.[id] ?? {}),
                };
                break;
            default:
                // TODO: Improve the error
                throw new Error("Unknown Context Menu Type");
        }
    }
}
//# sourceMappingURL=context-menu-interaction.js.map