import type { APIApplicationCommandAutocompleteInteraction, APIApplicationCommandInteractionDataOption, APIApplicationCommandOptionChoice, APIInteractionGuildMember } from "discord-api-types/v10";
import type { Snowflake } from "discord-snowflake";
import type Application from "../../application.js";
import type { Choices } from "../../commands/options/choices.js";
import type { APIApplicationCommandInteractionDataAutocompleteOption } from "../../commands/options/option.js";
import type { Autocomplete, RequestBody, ResponseHandler } from "../../interfaces.js";
import type { AutocompleteInteractionResponseTypes } from "./types.js";
export default class AutocompleteInteraction<T extends APIApplicationCommandOptionChoice> implements Autocomplete<T> {
    #private;
    readonly name: string;
    readonly token: string;
    readonly target: APIApplicationCommandInteractionDataAutocompleteOption;
    readonly options: Map<string, APIApplicationCommandInteractionDataOption>;
    readonly channelId: Snowflake | undefined;
    readonly guildId: Snowflake | undefined;
    readonly member: APIInteractionGuildMember | undefined;
    constructor(application: Application, json: RequestBody<APIApplicationCommandAutocompleteInteraction>, respond: ResponseHandler, type: AutocompleteInteractionResponseTypes);
    reply(options: Choices<T>): Promise<void>;
}
