var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _AutocompleteInteraction_application, _AutocompleteInteraction_type, _AutocompleteInteraction_respond;
import { isAutocompleteOption } from "../../commands/options/option.js";
import { ResponseStatus } from "../../requests/response.js";
// TODO: Specify string or number?
export default class AutocompleteInteraction {
    constructor(application, 
    // This will need to be changed to a more generic version someday, but for now
    // is the only type
    json, respond, type) {
        this.options = new Map();
        _AutocompleteInteraction_application.set(this, void 0);
        _AutocompleteInteraction_type.set(this, void 0);
        _AutocompleteInteraction_respond.set(this, void 0);
        __classPrivateFieldSet(this, _AutocompleteInteraction_type, type, "f");
        __classPrivateFieldSet(this, _AutocompleteInteraction_application, application, "f");
        __classPrivateFieldSet(this, _AutocompleteInteraction_respond, respond, "f");
        this.token = json.token;
        this.name = json.data.name;
        const target = json.data?.options?.find((option) => isAutocompleteOption(option) && option.focused);
        if (target == null) {
            throw new Error("No target option was specified");
        }
        this.target = target;
        json.data?.options?.forEach((option) => {
            this.options.set(option.name.toLowerCase(), option);
        });
        // TEMPORARY
        this.member = json.member;
    }
    async reply(options) {
        return __classPrivateFieldGet(this, _AutocompleteInteraction_respond, "f").call(this, ResponseStatus.OK, {
            type: __classPrivateFieldGet(this, _AutocompleteInteraction_type, "f"),
            data: {
                choices: options.serialize(),
            },
        });
    }
}
_AutocompleteInteraction_application = new WeakMap(), _AutocompleteInteraction_type = new WeakMap(), _AutocompleteInteraction_respond = new WeakMap();
//# sourceMappingURL=autocomplete-interaction.js.map