/// <reference types="@cloudflare/workers-types" />
import type { InteractionResponseType } from "discord-api-types/v10";
import type Application from "../../application.js";
import type { IntegerOption, NumberOption, StringOption } from "../../commands/options/index.js";
import type { Awaitable } from "../../interfaces.js";
import type SlashCommandAutocompleteInteraction from "./application-command-autocomplete.js";
export declare type AutocompleteInteractionResponseTypes = InteractionResponseType.ApplicationCommandAutocompleteResult;
export declare type AutocompleteInteractionTypes = SlashCommandAutocompleteInteraction;
export declare type AutocompleteTypes = SlashCommandAutocompleteType;
export declare type SlashCommandAutocompleteType = StringOption | IntegerOption | NumberOption;
export interface Autocomplete<T extends AutocompleteInteractionTypes> {
    autocomplete?: (interaction: T, application: Application, request: Request) => Awaitable;
}
