import type { APIInteractionGuildMember, APIMessage, APIMessageComponentInteraction } from "discord-api-types/v10";
import { InteractionType } from "discord-api-types/v10";
import type { Snowflake } from "discord-snowflake";
import type Application from "../../application.js";
import type { Interaction, InteractionMessageModifiers, InteractionReply, RequestBody, ResponseHandler } from "../../interfaces.js";
export default class MessageComponentInteraction implements Interaction {
    #private;
    readonly type = InteractionType.MessageComponent;
    readonly token: string;
    readonly customId: string;
    readonly messages: InteractionMessageModifiers;
    readonly channelId: Snowflake | undefined;
    readonly guildId: Snowflake | undefined;
    readonly member: APIInteractionGuildMember | undefined;
    readonly message: APIMessage | undefined;
    constructor(application: Application, json: RequestBody<APIMessageComponentInteraction>, respond: ResponseHandler);
    defer(): Promise<void>;
    reply({ message, embed, components, ephemeral, queue, }: InteractionReply): Promise<string>;
}
