var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _MessageComponentInteraction_application, _MessageComponentInteraction_respond, _MessageComponentInteraction_replied;
import { createInteractionFollowup, deleteInteractionFollowup, editInteractionFollowup, } from "discord-api-methods";
import { InteractionResponseType, InteractionType, MessageFlags, } from "discord-api-types/v10";
import { isActionRow } from "../../components/action-row.js";
import Config from "../../config.js";
import { ResponseStatus } from "../../requests/response.js";
export default class MessageComponentInteraction {
    constructor(application, json, respond) {
        this.type = InteractionType.MessageComponent;
        _MessageComponentInteraction_application.set(this, void 0);
        _MessageComponentInteraction_respond.set(this, void 0);
        _MessageComponentInteraction_replied.set(this, void 0);
        __classPrivateFieldSet(this, _MessageComponentInteraction_application, application, "f");
        __classPrivateFieldSet(this, _MessageComponentInteraction_respond, respond, "f");
        this.token = json.token;
        this.customId = json.data?.custom_id ?? "";
        // TODO: Make these records
        this.channelId = json.channel_id;
        this.guildId = json.guild_id;
        this.member = json.member;
        this.message = json.message;
        // TODO: Rename?
        this.messages = {
            edit: async (data, id = "@original") => editInteractionFollowup(Config.getApplicationId(), this.token, id, data),
            delete: async (id = "@original") => deleteInteractionFollowup(Config.getApplicationId(), this.token, id),
        };
        __classPrivateFieldSet(this, _MessageComponentInteraction_replied, false, "f");
    }
    async defer() {
        return __classPrivateFieldGet(this, _MessageComponentInteraction_respond, "f").call(this, ResponseStatus.OK, {
            type: InteractionResponseType.DeferredChannelMessageWithSource,
        });
    }
    async reply({ message, embed, components, ephemeral = false, queue = false, }) {
        const payload = {
            type: InteractionResponseType.ChannelMessageWithSource,
            data: {},
        };
        if (message != null) {
            payload.data.content = message;
        }
        if (ephemeral) {
            payload.data.flags = MessageFlags.Ephemeral;
        }
        if (embed != null) {
            payload.data.embeds = []
                .concat(embed)
                .map((item) => item.serialize());
        }
        if (components != null) {
            components.forEach((component) => {
                if (isActionRow(component)) {
                    component.components.forEach((child) => {
                        __classPrivateFieldGet(this, _MessageComponentInteraction_application, "f").addComponent(child);
                    });
                }
                else {
                    __classPrivateFieldGet(this, _MessageComponentInteraction_application, "f").addComponent(component);
                }
            });
            payload.data.components = components?.map((component) => component.serialize());
        }
        if (!__classPrivateFieldGet(this, _MessageComponentInteraction_replied, "f") && !queue) {
            __classPrivateFieldSet(this, _MessageComponentInteraction_replied, true, "f");
            await __classPrivateFieldGet(this, _MessageComponentInteraction_respond, "f").call(this, ResponseStatus.OK, payload);
            return "@original";
        }
        const responseData = await createInteractionFollowup(Config.getApplicationId(), this.token, payload.data);
        return responseData.id;
    }
}
_MessageComponentInteraction_application = new WeakMap(), _MessageComponentInteraction_respond = new WeakMap(), _MessageComponentInteraction_replied = new WeakMap();
//# sourceMappingURL=message-component-interaction.js.map